/**
 * Freqtrade API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2021.12-dev21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';

/**
 * The PairHistory model module.
 * @module model/PairHistory
 * @version 2021.12-dev21
 */
class PairHistory {
    /**
     * Constructs a new <code>PairHistory</code>.
     * @alias module:model/PairHistory
     * @param strategy {String} 
     * @param pair {String} 
     * @param timeframe {String} 
     * @param timeframeMs {Number} 
     * @param columns {Array.<String>} 
     * @param data {Array.<Object>} 
     * @param length {Number} 
     * @param buySignals {Number} 
     * @param sellSignals {Number} 
     * @param lastAnalyzed {Date} 
     * @param lastAnalyzedTs {Number} 
     * @param dataStartTs {Number} 
     * @param dataStart {String} 
     * @param dataStop {String} 
     * @param dataStopTs {Number} 
     */
    constructor(strategy, pair, timeframe, timeframeMs, columns, data, length, buySignals, sellSignals, lastAnalyzed, lastAnalyzedTs, dataStartTs, dataStart, dataStop, dataStopTs) { 
        
        PairHistory.initialize(this, strategy, pair, timeframe, timeframeMs, columns, data, length, buySignals, sellSignals, lastAnalyzed, lastAnalyzedTs, dataStartTs, dataStart, dataStop, dataStopTs);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj, strategy, pair, timeframe, timeframeMs, columns, data, length, buySignals, sellSignals, lastAnalyzed, lastAnalyzedTs, dataStartTs, dataStart, dataStop, dataStopTs) { 
        obj['strategy'] = strategy;
        obj['pair'] = pair;
        obj['timeframe'] = timeframe;
        obj['timeframe_ms'] = timeframeMs;
        obj['columns'] = columns;
        obj['data'] = data;
        obj['length'] = length;
        obj['buy_signals'] = buySignals;
        obj['sell_signals'] = sellSignals;
        obj['last_analyzed'] = lastAnalyzed;
        obj['last_analyzed_ts'] = lastAnalyzedTs;
        obj['data_start_ts'] = dataStartTs;
        obj['data_start'] = dataStart;
        obj['data_stop'] = dataStop;
        obj['data_stop_ts'] = dataStopTs;
    }

    /**
     * Constructs a <code>PairHistory</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/PairHistory} obj Optional instance to populate.
     * @return {module:model/PairHistory} The populated <code>PairHistory</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new PairHistory();

            if (data.hasOwnProperty('strategy')) {
                obj['strategy'] = ApiClient.convertToType(data['strategy'], 'String');
            }
            if (data.hasOwnProperty('pair')) {
                obj['pair'] = ApiClient.convertToType(data['pair'], 'String');
            }
            if (data.hasOwnProperty('timeframe')) {
                obj['timeframe'] = ApiClient.convertToType(data['timeframe'], 'String');
            }
            if (data.hasOwnProperty('timeframe_ms')) {
                obj['timeframe_ms'] = ApiClient.convertToType(data['timeframe_ms'], 'Number');
            }
            if (data.hasOwnProperty('columns')) {
                obj['columns'] = ApiClient.convertToType(data['columns'], ['String']);
            }
            if (data.hasOwnProperty('data')) {
                obj['data'] = ApiClient.convertToType(data['data'], [Object]);
            }
            if (data.hasOwnProperty('length')) {
                obj['length'] = ApiClient.convertToType(data['length'], 'Number');
            }
            if (data.hasOwnProperty('buy_signals')) {
                obj['buy_signals'] = ApiClient.convertToType(data['buy_signals'], 'Number');
            }
            if (data.hasOwnProperty('sell_signals')) {
                obj['sell_signals'] = ApiClient.convertToType(data['sell_signals'], 'Number');
            }
            if (data.hasOwnProperty('last_analyzed')) {
                obj['last_analyzed'] = ApiClient.convertToType(data['last_analyzed'], 'Date');
            }
            if (data.hasOwnProperty('last_analyzed_ts')) {
                obj['last_analyzed_ts'] = ApiClient.convertToType(data['last_analyzed_ts'], 'Number');
            }
            if (data.hasOwnProperty('data_start_ts')) {
                obj['data_start_ts'] = ApiClient.convertToType(data['data_start_ts'], 'Number');
            }
            if (data.hasOwnProperty('data_start')) {
                obj['data_start'] = ApiClient.convertToType(data['data_start'], 'String');
            }
            if (data.hasOwnProperty('data_stop')) {
                obj['data_stop'] = ApiClient.convertToType(data['data_stop'], 'String');
            }
            if (data.hasOwnProperty('data_stop_ts')) {
                obj['data_stop_ts'] = ApiClient.convertToType(data['data_stop_ts'], 'Number');
            }
        }
        return obj;
    }


}

/**
 * @member {String} strategy
 */
PairHistory.prototype['strategy'] = undefined;

/**
 * @member {String} pair
 */
PairHistory.prototype['pair'] = undefined;

/**
 * @member {String} timeframe
 */
PairHistory.prototype['timeframe'] = undefined;

/**
 * @member {Number} timeframe_ms
 */
PairHistory.prototype['timeframe_ms'] = undefined;

/**
 * @member {Array.<String>} columns
 */
PairHistory.prototype['columns'] = undefined;

/**
 * @member {Array.<Object>} data
 */
PairHistory.prototype['data'] = undefined;

/**
 * @member {Number} length
 */
PairHistory.prototype['length'] = undefined;

/**
 * @member {Number} buy_signals
 */
PairHistory.prototype['buy_signals'] = undefined;

/**
 * @member {Number} sell_signals
 */
PairHistory.prototype['sell_signals'] = undefined;

/**
 * @member {Date} last_analyzed
 */
PairHistory.prototype['last_analyzed'] = undefined;

/**
 * @member {Number} last_analyzed_ts
 */
PairHistory.prototype['last_analyzed_ts'] = undefined;

/**
 * @member {Number} data_start_ts
 */
PairHistory.prototype['data_start_ts'] = undefined;

/**
 * @member {String} data_start
 */
PairHistory.prototype['data_start'] = undefined;

/**
 * @member {String} data_stop
 */
PairHistory.prototype['data_stop'] = undefined;

/**
 * @member {Number} data_stop_ts
 */
PairHistory.prototype['data_stop_ts'] = undefined;






export default PairHistory;

